/**
 * Cardano Wallet Backend API
 * <p align=\"right\"><img style=\"position: relative; top: -10em; margin-bottom: -12em;\" width=\"20%\" src=\"https://cardanodocs.com/img/cardano.png\"></img></p>
 *
 * OpenAPI spec version: 2021.3.4
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { ApiPostTransactionFeeData } from '../models';
import { ApiCoinSelection } from '../models';
/**
 * CoinSelectionsApi - axios parameter creator
 * @export
 */
export declare const CoinSelectionsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Select coins to cover the given set of payments.  Uses the <a href=\"https://iohk.io/blog/self-organisation-in-coin-selection/\"> Random-Improve coin selection algorithm</a>.
     * @summary Random
     * @param {ApiPostTransactionFeeData} body
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    selectCoins: (body: ApiPostTransactionFeeData, walletId: string, options?: any) => Promise<RequestArgs>;
};
/**
 * CoinSelectionsApi - functional programming interface
 * @export
 */
export declare const CoinSelectionsApiFp: (configuration?: Configuration) => {
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Select coins to cover the given set of payments.  Uses the <a href=\"https://iohk.io/blog/self-organisation-in-coin-selection/\"> Random-Improve coin selection algorithm</a>.
     * @summary Random
     * @param {ApiPostTransactionFeeData} body
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    selectCoins(body: ApiPostTransactionFeeData, walletId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ApiCoinSelection>>;
};
/**
 * CoinSelectionsApi - factory interface
 * @export
 */
export declare const CoinSelectionsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Select coins to cover the given set of payments.  Uses the <a href=\"https://iohk.io/blog/self-organisation-in-coin-selection/\"> Random-Improve coin selection algorithm</a>.
     * @summary Random
     * @param {ApiPostTransactionFeeData} body
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    selectCoins(body: ApiPostTransactionFeeData, walletId: string, options?: any): AxiosPromise<ApiCoinSelection>;
};
/**
 * CoinSelectionsApi - object-oriented interface
 * @export
 * @class CoinSelectionsApi
 * @extends {BaseAPI}
 */
export declare class CoinSelectionsApi extends BaseAPI {
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Select coins to cover the given set of payments.  Uses the <a href=\"https://iohk.io/blog/self-organisation-in-coin-selection/\"> Random-Improve coin selection algorithm</a>.
     * @summary Random
     * @param {ApiPostTransactionFeeData} body
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoinSelectionsApi
     */
    selectCoins(body: ApiPostTransactionFeeData, walletId: string, options?: any): Promise<import("axios").AxiosResponse<ApiCoinSelection>>;
}
