"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StakePoolsApi = exports.StakePoolsApiFactory = exports.StakePoolsApiFp = exports.StakePoolsApiAxiosParamCreator = void 0;
/* tslint:disable */
/* eslint-disable */
/**
 * Cardano Wallet Backend API
 * <p align=\"right\"><img style=\"position: relative; top: -10em; margin-bottom: -12em;\" width=\"20%\" src=\"https://cardanodocs.com/img/cardano.png\"></img></p>
 *
 * OpenAPI spec version: 2021.3.4
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
var axios_1 = require("axios");
// Some imports not used depending on template conditions
// @ts-ignore
var base_1 = require("../base");
/**
 * StakePoolsApi - axios parameter creator
 * @export
 */
exports.StakePoolsApiAxiosParamCreator = function (configuration) {
    var _this = this;
    return {
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Estimate fee for joining or leaving a stake pool. Note that it is an estimation because a delegation induces a transaction for which coins have to be selected randomly within the wallet. Because of this randomness, fees can only be estimated.
         * @summary Estimate Fee
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDelegationFee: function (walletId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'walletId' is not null or undefined
                    if (walletId === null || walletId === undefined) {
                        throw new base_1.RequiredError('walletId', 'Required parameter walletId was null or undefined when calling getDelegationFee.');
                    }
                    localVarPath = "/wallets/{walletId}/delegation-fees"
                        .replace("{" + "walletId" + "}", encodeURIComponent(String(walletId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         * Returns the current status of the stake pools maintenance actions.
         * @summary View maintenance actions
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMaintenanceActions: function (options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    localVarPath = "/stake-pools/maintenance-actions";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Delegate all (current and future) addresses from the given wallet to the given stake pool.  <strong>Note:</strong> Bech32-encoded stake pool identifiers can vary in length.
         * @summary Join
         * @param {ApiWalletPassphrase} body
         * @param {string} stakePoolId
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        joinStakePool: function (body, stakePoolId, walletId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'body' is not null or undefined
                    if (body === null || body === undefined) {
                        throw new base_1.RequiredError('body', 'Required parameter body was null or undefined when calling joinStakePool.');
                    }
                    // verify required parameter 'stakePoolId' is not null or undefined
                    if (stakePoolId === null || stakePoolId === undefined) {
                        throw new base_1.RequiredError('stakePoolId', 'Required parameter stakePoolId was null or undefined when calling joinStakePool.');
                    }
                    // verify required parameter 'walletId' is not null or undefined
                    if (walletId === null || walletId === undefined) {
                        throw new base_1.RequiredError('walletId', 'Required parameter walletId was null or undefined when calling joinStakePool.');
                    }
                    localVarPath = "/stake-pools/{stakePoolId}/wallets/{walletId}"
                        .replace("{" + "stakePoolId" + "}", encodeURIComponent(String(stakePoolId)))
                        .replace("{" + "walletId" + "}", encodeURIComponent(String(walletId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'PUT' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  List all known stake pools ordered by descending `non_myopic_member_rewards`. The `non_myopic_member_rewards` — and thus the ordering — depends on the `?stake` query parameter.  Some pools _may_ also have metadata attached to them.
         * @summary List
         * @param {number} stake The stake the user intends to delegate in Lovelace. Required.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listStakePools: function (stake, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions;
                return __generator(this, function (_a) {
                    // verify required parameter 'stake' is not null or undefined
                    if (stake === null || stake === undefined) {
                        throw new base_1.RequiredError('stake', 'Required parameter stake was null or undefined when calling listStakePools.');
                    }
                    localVarPath = "/stake-pools";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'GET' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    if (stake !== undefined) {
                        localVarQueryParameter['stake'] = stake;
                    }
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         * Performs maintenance actions on stake pools, such as triggering metadata garbage collection.  Actions may not be instantaneous.
         * @summary Trigger Maintenance actions
         * @param {ApiMaintenanceActionPostData} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postMaintenanceAction: function (body, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'body' is not null or undefined
                    if (body === null || body === undefined) {
                        throw new base_1.RequiredError('body', 'Required parameter body was null or undefined when calling postMaintenanceAction.');
                    }
                    localVarPath = "/stake-pools/maintenance-actions";
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'POST' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Stop delegating completely. The wallet's stake will become inactive.  > ⚠️  Disclaimer ⚠️ > > This endpoint historically use to take a stake pool id as a path parameter. > However, retiring from delegation is ubiquitous and not tight to a particular > stake pool. For backward-compatibility reasons, sending stake pool ids as path > parameter will still be accepted by the server but new integrations are > encouraged to provide a placeholder asterisk `*` instead.
         * @summary Quit
         * @param {ApiWalletPassphrase} body
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quitStakePool: function (body, walletId, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var localVarPath, localVarUrlObj, baseOptions, localVarRequestOptions, localVarHeaderParameter, localVarQueryParameter, query, key, key, headersFromBaseOptions, needsSerialization;
                return __generator(this, function (_a) {
                    // verify required parameter 'body' is not null or undefined
                    if (body === null || body === undefined) {
                        throw new base_1.RequiredError('body', 'Required parameter body was null or undefined when calling quitStakePool.');
                    }
                    // verify required parameter 'walletId' is not null or undefined
                    if (walletId === null || walletId === undefined) {
                        throw new base_1.RequiredError('walletId', 'Required parameter walletId was null or undefined when calling quitStakePool.');
                    }
                    localVarPath = "/stake-pools/*/wallets/{walletId}"
                        .replace("{" + "walletId" + "}", encodeURIComponent(String(walletId)));
                    localVarUrlObj = new URL(localVarPath, 'https://example.com');
                    if (configuration) {
                        baseOptions = configuration.baseOptions;
                    }
                    localVarRequestOptions = __assign(__assign({ method: 'DELETE' }, baseOptions), options);
                    localVarHeaderParameter = {};
                    localVarQueryParameter = {};
                    localVarHeaderParameter['Content-Type'] = 'application/json';
                    query = new URLSearchParams(localVarUrlObj.search);
                    for (key in localVarQueryParameter) {
                        query.set(key, localVarQueryParameter[key]);
                    }
                    for (key in options.query) {
                        query.set(key, options.query[key]);
                    }
                    localVarUrlObj.search = (new URLSearchParams(query)).toString();
                    headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
                    localVarRequestOptions.headers = __assign(__assign(__assign({}, localVarHeaderParameter), headersFromBaseOptions), options.headers);
                    needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
                    localVarRequestOptions.data = needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");
                    return [2 /*return*/, {
                            url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                            options: localVarRequestOptions,
                        }];
                });
            });
        },
    };
};
/**
 * StakePoolsApi - functional programming interface
 * @export
 */
exports.StakePoolsApiFp = function (configuration) {
    return {
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Estimate fee for joining or leaving a stake pool. Note that it is an estimation because a delegation induces a transaction for which coins have to be selected randomly within the wallet. Because of this randomness, fees can only be estimated.
         * @summary Estimate Fee
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDelegationFee: function (walletId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).getDelegationFee(walletId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         * Returns the current status of the stake pools maintenance actions.
         * @summary View maintenance actions
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMaintenanceActions: function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).getMaintenanceActions(options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Delegate all (current and future) addresses from the given wallet to the given stake pool.  <strong>Note:</strong> Bech32-encoded stake pool identifiers can vary in length.
         * @summary Join
         * @param {ApiWalletPassphrase} body
         * @param {string} stakePoolId
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        joinStakePool: function (body, stakePoolId, walletId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).joinStakePool(body, stakePoolId, walletId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  List all known stake pools ordered by descending `non_myopic_member_rewards`. The `non_myopic_member_rewards` — and thus the ordering — depends on the `?stake` query parameter.  Some pools _may_ also have metadata attached to them.
         * @summary List
         * @param {number} stake The stake the user intends to delegate in Lovelace. Required.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listStakePools: function (stake, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).listStakePools(stake, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         * Performs maintenance actions on stake pools, such as triggering metadata garbage collection.  Actions may not be instantaneous.
         * @summary Trigger Maintenance actions
         * @param {ApiMaintenanceActionPostData} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postMaintenanceAction: function (body, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).postMaintenanceAction(body, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Stop delegating completely. The wallet's stake will become inactive.  > ⚠️  Disclaimer ⚠️ > > This endpoint historically use to take a stake pool id as a path parameter. > However, retiring from delegation is ubiquitous and not tight to a particular > stake pool. For backward-compatibility reasons, sending stake pool ids as path > parameter will still be accepted by the server but new integrations are > encouraged to provide a placeholder asterisk `*` instead.
         * @summary Quit
         * @param {ApiWalletPassphrase} body
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quitStakePool: function (body, walletId, options) {
            return __awaiter(this, void 0, void 0, function () {
                var localVarAxiosArgs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, exports.StakePoolsApiAxiosParamCreator(configuration).quitStakePool(body, walletId, options)];
                        case 1:
                            localVarAxiosArgs = _a.sent();
                            return [2 /*return*/, function (axios, basePath) {
                                    if (axios === void 0) { axios = axios_1.default; }
                                    if (basePath === void 0) { basePath = base_1.BASE_PATH; }
                                    var axiosRequestArgs = __assign(__assign({}, localVarAxiosArgs.options), { url: basePath + localVarAxiosArgs.url });
                                    return axios.request(axiosRequestArgs);
                                }];
                    }
                });
            });
        },
    };
};
/**
 * StakePoolsApi - factory interface
 * @export
 */
exports.StakePoolsApiFactory = function (configuration, basePath, axios) {
    return {
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Estimate fee for joining or leaving a stake pool. Note that it is an estimation because a delegation induces a transaction for which coins have to be selected randomly within the wallet. Because of this randomness, fees can only be estimated.
         * @summary Estimate Fee
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDelegationFee: function (walletId, options) {
            return exports.StakePoolsApiFp(configuration).getDelegationFee(walletId, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         * Returns the current status of the stake pools maintenance actions.
         * @summary View maintenance actions
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getMaintenanceActions: function (options) {
            return exports.StakePoolsApiFp(configuration).getMaintenanceActions(options).then(function (request) { return request(axios, basePath); });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Delegate all (current and future) addresses from the given wallet to the given stake pool.  <strong>Note:</strong> Bech32-encoded stake pool identifiers can vary in length.
         * @summary Join
         * @param {ApiWalletPassphrase} body
         * @param {string} stakePoolId
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        joinStakePool: function (body, stakePoolId, walletId, options) {
            return exports.StakePoolsApiFp(configuration).joinStakePool(body, stakePoolId, walletId, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  List all known stake pools ordered by descending `non_myopic_member_rewards`. The `non_myopic_member_rewards` — and thus the ordering — depends on the `?stake` query parameter.  Some pools _may_ also have metadata attached to them.
         * @summary List
         * @param {number} stake The stake the user intends to delegate in Lovelace. Required.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listStakePools: function (stake, options) {
            return exports.StakePoolsApiFp(configuration).listStakePools(stake, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         * Performs maintenance actions on stake pools, such as triggering metadata garbage collection.  Actions may not be instantaneous.
         * @summary Trigger Maintenance actions
         * @param {ApiMaintenanceActionPostData} body
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postMaintenanceAction: function (body, options) {
            return exports.StakePoolsApiFp(configuration).postMaintenanceAction(body, options).then(function (request) { return request(axios, basePath); });
        },
        /**
         * <p align=\"right\">status: <strong>stable</strong></p>  Stop delegating completely. The wallet's stake will become inactive.  > ⚠️  Disclaimer ⚠️ > > This endpoint historically use to take a stake pool id as a path parameter. > However, retiring from delegation is ubiquitous and not tight to a particular > stake pool. For backward-compatibility reasons, sending stake pool ids as path > parameter will still be accepted by the server but new integrations are > encouraged to provide a placeholder asterisk `*` instead.
         * @summary Quit
         * @param {ApiWalletPassphrase} body
         * @param {string} walletId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quitStakePool: function (body, walletId, options) {
            return exports.StakePoolsApiFp(configuration).quitStakePool(body, walletId, options).then(function (request) { return request(axios, basePath); });
        },
    };
};
/**
 * StakePoolsApi - object-oriented interface
 * @export
 * @class StakePoolsApi
 * @extends {BaseAPI}
 */
var StakePoolsApi = /** @class */ (function (_super) {
    __extends(StakePoolsApi, _super);
    function StakePoolsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Estimate fee for joining or leaving a stake pool. Note that it is an estimation because a delegation induces a transaction for which coins have to be selected randomly within the wallet. Because of this randomness, fees can only be estimated.
     * @summary Estimate Fee
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.getDelegationFee = function (walletId, options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).getDelegationFee(walletId, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     * Returns the current status of the stake pools maintenance actions.
     * @summary View maintenance actions
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.getMaintenanceActions = function (options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).getMaintenanceActions(options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Delegate all (current and future) addresses from the given wallet to the given stake pool.  <strong>Note:</strong> Bech32-encoded stake pool identifiers can vary in length.
     * @summary Join
     * @param {ApiWalletPassphrase} body
     * @param {string} stakePoolId
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.joinStakePool = function (body, stakePoolId, walletId, options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).joinStakePool(body, stakePoolId, walletId, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  List all known stake pools ordered by descending `non_myopic_member_rewards`. The `non_myopic_member_rewards` — and thus the ordering — depends on the `?stake` query parameter.  Some pools _may_ also have metadata attached to them.
     * @summary List
     * @param {number} stake The stake the user intends to delegate in Lovelace. Required.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.listStakePools = function (stake, options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).listStakePools(stake, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     * Performs maintenance actions on stake pools, such as triggering metadata garbage collection.  Actions may not be instantaneous.
     * @summary Trigger Maintenance actions
     * @param {ApiMaintenanceActionPostData} body
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.postMaintenanceAction = function (body, options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).postMaintenanceAction(body, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    /**
     * <p align=\"right\">status: <strong>stable</strong></p>  Stop delegating completely. The wallet's stake will become inactive.  > ⚠️  Disclaimer ⚠️ > > This endpoint historically use to take a stake pool id as a path parameter. > However, retiring from delegation is ubiquitous and not tight to a particular > stake pool. For backward-compatibility reasons, sending stake pool ids as path > parameter will still be accepted by the server but new integrations are > encouraged to provide a placeholder asterisk `*` instead.
     * @summary Quit
     * @param {ApiWalletPassphrase} body
     * @param {string} walletId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof StakePoolsApi
     */
    StakePoolsApi.prototype.quitStakePool = function (body, walletId, options) {
        var _this = this;
        return exports.StakePoolsApiFp(this.configuration).quitStakePool(body, walletId, options).then(function (request) { return request(_this.axios, _this.basePath); });
    };
    return StakePoolsApi;
}(base_1.BaseAPI));
exports.StakePoolsApi = StakePoolsApi;
//# sourceMappingURL=stake-pools-api.js.map