/* tslint:disable */
/* eslint-disable */
/**
 * Cardano Wallet Backend API
 * <p align=\"right\"><img style=\"position: relative; top: -10em; margin-bottom: -12em;\" width=\"20%\" src=\"https://cardanodocs.com/img/cardano.png\"></img></p> 
 *
 * OpenAPI spec version: 2021.3.4
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
/**
 * An asset on the Cardano blockchain. An asset is uniquely identified by its `policy_id` and `asset_name` (together, these form the _asset id_).  Two assets with the same `asset_name` and `policy_id` are interchangeable. Yet, different assets with a same `policy_id` but different `asset_name` are treated as separate assets, as are two assets with the same `asset_name` but different `policy_id`. 
 * @export
 * @interface WalletsAssetsAvailable
 */
export interface WalletsAssetsAvailable {
    /**
     * A unique identifier of the asset's monetary policy. The policy controls how assets of this kind are created and destroyed.  The contents are the blake2b-224 hash of the monetary policy script, encoded in hexadecimal. 
     * @type {string}
     * @memberof WalletsAssetsAvailable
     */
    policy_id: string;
    /**
     * The asset on-chain type which acts as a sub-identifier within a policy. Although we call it \"asset name\", the value needn't be text, and it could even be empty.  For policies with a single fungible asset item, asset name is typically an empty string.  This value can be up to 32 bytes of arbitrary data (which is 64 hexadecimal digits). 
     * @type {string}
     * @memberof WalletsAssetsAvailable
     */
    asset_name: string;
    /**
     * Number of assets for the given `policy_id` and `asset_name`. 
     * @type {number}
     * @memberof WalletsAssetsAvailable
     */
    quantity: number;
}
